import QtQuick 1.1
import com.nokia.meego 1.0


Page {
    id: addPage
    orientationLock: PageOrientation.LockPortrait

    property int editingIndex: 0
    property alias name: nameInput.text
    property alias ussd: ussdInput.text

    tools: addTools

    Rectangle {

        anchors {
            horizontalCenter: parent.horizontalCenter
            fill: parent
        }
        color:"black"

        Column {
            anchors.horizontalCenter: parent.horizontalCenter
            width:parent.width
            spacing: 20

            Text {
                anchors.horizontalCenter: parent.horizontalCenter
                font.pixelSize: 30
                color: "white"
                text: qsTr("Request name:")
            }
            Rectangle {
                width: 300
                height: 60
                radius: 5
                color: "black"
                border.width: 2
                border.color: "white"
                anchors.horizontalCenter: parent.horizontalCenter

                TextInput {
                    id:nameInput
                    anchors {
                        verticalCenter: parent.verticalCenter
                        horizontalCenter: parent.horizontalCenter
                    }
                    width: parent.width - 20
                    height:parent.height - 10
                    color:"white"
                    font.pointSize: 20
                    text:qsTr("Name")
                    onAccepted: {
                        nameInput.closeSoftwareInputPanel();
                    }
                    MouseArea {
                        anchors.fill: parent
                        onClicked: {
                            ussdkbd.visible = false

                            if (!nameInput.activeFocus) {
                                nameInput.forceActiveFocus()
                                nameInput.openSoftwareInputPanel();
                            } else {
                                nameInput.focus = false;
                                nameInput.closeSoftwareInputPanel();
                            }
                        }
                        onPressAndHold: nameInput.closeSoftwareInputPanel();
                    }

                }
            }

            Text {
                anchors.horizontalCenter: parent.horizontalCenter
                font.pixelSize: 30
                color: "white"
                text: qsTr("USSD command:")
            }

            Rectangle {
                width: 300
                height: 60
                radius: 5
                color: "black"
                border.width: 2
                border.color: "white"
                anchors.horizontalCenter: parent.horizontalCenter

                TextInput {
                    id:ussdInput
                    anchors {
                        verticalCenter: parent.verticalCenter
                        horizontalCenter: parent.horizontalCenter
                    }
                    width: parent.width - 20
                    height:parent.height - 10
                    color:"white"
                    font.pointSize: 20
                    text:"*"
                    activeFocusOnPress: false
                    MouseArea {
                        anchors.fill: parent
                        onClicked: {
                            if (!ussdInput.activeFocus) {
                                ussdInput.forceActiveFocus()
                                ussdkbd.textinput = ussdInput
                                nameInput.closeSoftwareInputPanel();
                                ussdkbd.visible = true
                            } else {
                                ussdInput.focus = false
                                ussdkbd.visible = false
                            }
                        }
                    }

                }
            }
            UssdKeyboard {
                id:ussdkbd
                anchors.horizontalCenter: parent.horizontalCenter
                visible:false
            }

        }
    }
    ToolBarLayout {
        id: addTools
        visible: false
        ToolIcon {
            platformIconId: "toolbar-back"
            anchors.left: (parent === undefined) ? undefined : parent.left
            onClicked: {
                ussdkbd.visible = false
                appWindow.pageStack.pop()
            }
        }
        ToolIcon {
            platformIconId: "toolbar-done"
            anchors.horizontalCenter: (parent === undefined) ? undefined : parent.horizontalCenter
            onClicked: {
                ussdkbd.visible = false
                if (editingIndex >= 0) {
                    mainPage.model.set(editingIndex, {"name":addPage.name, "ussd":addPage.ussd})
                    ussdengine.setUssd(editingIndex, addPage.name, addPage.ussd)
                } else {
                    mainPage.model.append({"name":addPage.name, "ussd":addPage.ussd})
                    ussdengine.addUssd(addPage.name, addPage.ussd)
                }

                appWindow.pageStack.pop()
            }
        }
    }
}
