﻿// import QtQuick 1.0 // to target S60 5th Edition or Maemo 5
import QtQuick 1.1
import com.nokia.meego 1.0


Item {
    property int selectedIndex: -1
    property alias model: ussdModel
    property alias count: ussdModel.count
    property alias list: ussdListView
    width: 480
    height: 750
    clip: true

    ListModel {
        id: ussdModel

    }

    Component {
        id: ussdDelegate
        Image {
            id: delegateImage
            property alias delIconVisible: deleteIcon.visible
            property alias sendIconVisible: sendIcon.visible

            source: "images/ussdlist.png"
            width: 480
            height: 100
            Column {
                anchors.verticalCenter: parent.verticalCenter
                anchors.left: parent.left
                anchors.leftMargin: 10
                Text {
                    font.pixelSize: 30
                    font.bold: false
                    color: "#EEEEEE"
                    text: name

                }

                Text {
                    font.pixelSize: 20
                    color: "yellow"
                    text: ussd

                }


            } // column

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    selectedIndex = index;
                }
            }

            ToolIcon {
                id: sendIcon
                platformIconId: "toolbar-mediacontrol-play"
                visible: false
                anchors {
                    right: parent.right
                    rightMargin: 50
                    verticalCenter: parent.verticalCenter
                }
                onClicked: {
                    mainPage.sendUSSD();
                }
            }

            ToolIcon {
                id: deleteIcon
                platformIconId: "toolbar-delete"
                visible: false
                anchors {
                    right: parent.right
                    rightMargin: 0
                    verticalCenter: parent.verticalCenter
                }
                onClicked: {
                    deleteDialog.open();
                }
            }

            states: [
                State {
                    name: "selected"
                    when: (index == selectedIndex)
                    PropertyChanges {
                        target: delegateImage;
                        source: "images/ussdlisthi.png"
                        delIconVisible: true
                        sendIconVisible: true
                    }
                }
            ]
        }

    }

    ListView {
        id: ussdListView
        model: ussdModel
        delegate: ussdDelegate
        anchors.fill: parent

    }

    Component.onCompleted: {
        ussdModel.clear()
        for (var i = 0; i < ussdengine.getCount(); i++) {
            ussdModel.append({"name":ussdengine.getNameAt(i), "ussd":ussdengine.getUssdAt(i)})
        }
    }

    QueryDialog {
        id: deleteDialog
        titleText: qsTr("Delete item?")
        message: qsTr("This item will be removed from list.")
        acceptButtonText: qsTr("Delete")

        rejectButtonText: qsTr("Cancel")
        onRejected: {}
        onAccepted: {
            ussdengine.removeUssd(mainPage.currentIndex)
            mainPage.model.remove(mainPage.currentIndex)
        }
    }
}

